\ProvidesClass{cartadma}[2002/07/12]
\RequirePackage{graphics}
\RequirePackage{url}
\RequirePackage[american,english,spanish,catalan]{babel}
\RequirePackage{ifthen}
\RequirePackage{calc}

\def\elcentre{}%
\def\ladreca{Cam\'{\i} de Vera, 14\\46022 Val\`encia (Spain)}%
\def\eltelefon{96 387 7660 ext.\ 76600}%
\def\elfax{96 387 7669}%
\def\lemail{depmat@upvnet.upv.es}%
\def\elweb{\url{http://www.dma.upv.es/}}%
\def\laciutat{Val\`encia}%
\def\laciutatc{Val\`encia, }%
\def\centre#1{\renewcommand{\elcentre}{#1}}%
\def\adreca#1{\renewcommand{\ladreca}{#1}}%
\def\telefon#1{\renewcommand{\eltelefon}{#1}}%
\def\fax#1{\renewcommand{\elfax}{#1}}%
\def\email#1{\renewcommand{\lemail}{#1}}%
\def\web#1{\renewcommand{\elweb}{\url{#1}}}%
\def\ciutat#1{%
  \renewcommand{\laciutat}{#1}%
  \renewcommand\laciutatc{\ifthenelse{\equal{}{\laciutat}}{}{\laciutat, }}}%
\def\alcoi{%
  \centre{EPS Alcoi}%
  \adreca{Passeig del Viaducte, 1\\03800 Alcoi (Spain)}%
  \ciutat{Alcoi}}%
\def\vera{%
  \centre{}%
  \adreca{Cam\'{\i} de Vera, 14\\46022 Val\`encia (Spain)}%
  \ciutat{Val\`encia}}%
\def\blasco{%
  \centre{EU Enginyeria T\`ecnica Agr\'\i cola}%
  \adreca{Avda.\ Blasco Ib\'a\~nez, 21\\46010 Val\`encia}%
  \ciutat{Val\`encia}}%
\def\gandia{%
  \centre{EPS Gandia}%
  \adreca{Carretera Natzaret-Oliva, s/n\\46730 El Grau de Gandia
    (Spain)}%
  \ciutat{El Grau de Gandia}}%
  
\newcommand{\espaisignatura}{6\medskipamount}
\newcommand{\@lasignatura}{}
\newcommand{\mysignature}[1]{%
  \renewcommand{\espaisignatura}{0pt}%
  \renewcommand{\@lasignatura}{#1\\}}
%
\newcommand{\black}{}





\DeclareOption{10pt}{\PassOptionsToClass{a4paper,10pt}{letter}}
\DeclareOption{11pt}{\PassOptionsToClass{a4paper,11pt}{letter}}
\DeclareOption{12pt}{\PassOptionsToClass{a4paper,12pt}{letter}}
\DeclareOption{black}{\renewcommand{\black}{n}}
\DeclareOption{noblack}{\renewcommand{\black}{}}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Opcions per a catal %%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\DeclareOption{catalan}{%
  \frenchspacing
  \PassOptionsToPackage{spanish,catalan}{babel}%
    \adreca{Cam\'{\i} de Vera, 14\\46022 Val\`encia (Spain)}%
    \ciutat{Val\`encia}%
                                %
    \def\alcoi{%
      \centre{EPS Alcoi}%
      \adreca{Passeig del Viaducte, 1\\03800 Alcoi (Spain)}%
      \ciutat{Alcoi}}%
    \def\vera{%
      \centre{}%
      \adreca{Cam\'{\i} de Vera, 14\\46022 Val\`encia (Spain)}%
      \ciutat{Val\`encia}}%
    \def\blasco{%
      \centre{EU Enginyeria T\`ecnica Agr\'\i cola}%
      \adreca{Avda.\ Blasco Ib\'a\~nez, 21\\46010 Val\`encia (Spain)}%
      \ciutat{Val\`encia}}%
    \def\gandia{%
      \centre{EPS Gandia}%
      \adreca{Carretera Natzaret-Oliva, s/n\\46730 El Grau de Gandia
        (Spain)}%
      \ciutat{El Grau de Gandia}}%
                                %
  \AtBeginDocument{%
    \selectlanguage{catalan}%
    \def\opening#1{%\ifx\@empty\fromaddress
      \thispagestyle{firstpage}%
                                %    {\raggedleft\@date\par}%
                                %  \else  % home address
                                %    \thispagestyle{empty}%
                                %     {\raggedleft\begin{tabular}{l@{}}\ignorespaces
                                %       \fromaddress \\*[2\parskip]%
                                % %      \@date \end{tabular}\par}%
                                %       \end{tabular}\par}%
                                %  \fi
                                %    \vspace{2\parskip}%
      {\raggedright \toname \\\toaddress \par}%
      \vspace{2\parskip}%
      #1\par\nobreak}%
                                %
    \def\closing#1{\par\nobreak\vspace{\parskip}%
      \stopbreaks
      \noindent
                                % \ifx\@empty\fromaddress\else
                                % \hspace*{\longindentation}\fi
      \parbox{\indentedwidth}{\raggedright
        \ignorespaces
        #1\\[\espaisignatura]\@lasignatura
        \ifx\@empty\fromsig
        \fromname
        \else \fromsig \fi\strut}%
      \par\medskip\@date}%
    \def\ps@firstpage{%
      \def\@oddhead{\raisebox{34\p@}[\z@]{%
          \hspace*{-24mm}\resizebox{!}{15mm}{%
            \includegraphics{logoupvv\black}}\qquad
          \resizebox{!}{15mm}{\includegraphics{dmav}}}\qquad
        \raisebox{34\p@}[\z@]%
        {\parbox[b]{5cm}{\scriptsize\sffamily
            \ifthenelse{\equal{}{\elcentre}}{}{\elcentre \\ }
            \ladreca\\
            Tel\`efon \eltelefon\\
            Fax \elfax\\
            \lemail\\
            \elweb}}}%
      \def\@oddfoot{}}}%
%\InputIfFileExists{cartadma.cfg}{}{}
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Opcions per a spanish %%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\DeclareOption{spanish}{%
  \frenchspacing
  \PassOptionsToPackage{catalan,spanish}{babel}%
    \adreca{Camino de Vera, 14\\46022 Valencia (Spain)}%
    \ciutat{Valencia}%
                                %
    \def\alcoi{%
      \centre{EPS Alcoy}%
      \adreca{Paseo del Viaducto, 1\\03800 Alcoy (Spain)}%
      \ciutat{Alcoy}}%
    \def\vera{%
      \centre{}%
      \adreca{Camino de Vera, 14\\46022 Valencia (Spain)}%
      \ciutat{Valencia}}%
    \def\blasco{%
      \centre{EU Ingenier\'\i a T\'ecnica Agr\'\i cola}%
      \adreca{Avda.\ Blasco Ib\'a\~nez, 21\\46010 Valencia}%
      \ciutat{Valencia}}%
    \def\gandia{%
      \centre{EPS Gand\'\i a}%
      \adreca{Carretera Nazaret-Oliva, s/n\\46730 El Grao de Ganda
        (Spain)}%
      \ciutat{El Grao de Ganda}}%
                                %
  \AtBeginDocument{%
    \selectlanguage{spanish}%
    \def\opening#1{%\ifx\@empty\fromaddress
      \thispagestyle{firstpage}%
                                %  \else  % home address
                                %    \thispagestyle{empty}%
                                %     {\raggedleft\begin{tabular}{l@{}}\ignorespaces
                                %       \fromaddress \\*[2\parskip]%
                                % %      \@date \end{tabular}\par}%
                                %       \end{tabular}\par}%
                                %  \fi
      \vspace{2\parskip}%
      {\raggedright \toname \\ \toaddress \par}%
      \vspace{2\parskip}%
      {\raggedleft\@date\par}%
      \vspace{2\parskip}%
      #1\par\nobreak}%
                                %
    \def\closing#1{\par\nobreak\vspace{\parskip}%
      \stopbreaks
      \noindent
                                % \ifx\@empty\fromaddress\else
                                % \hspace*{\longindentation}\fi
      \hspace*{\longindentation}\parbox{\indentedwidth}{\raggedright
        \ignorespaces
        \hspace*{-\longindentation}#1%
        \\[\espaisignatura]\@lasignatura
        \ifx\@empty\fromsig
        \fromname
        \else \fromsig \fi\strut}%
      \par\medskip}%
    \def\ps@firstpage{%
      \def\@oddhead{\raisebox{34\p@}[\z@]{%
          \hspace*{-24mm}\resizebox{!}{15mm}{%
            \includegraphics{logoupvc\black}}\qquad
          \resizebox{!}{15mm}{\includegraphics{dmac}}}\qquad
        \raisebox{34\p@}[\z@]%
        {\parbox[b]{5cm}{\scriptsize\sffamily
            \ifthenelse{\equal{}{\elcentre}}{}{\elcentre \\ }
            \ladreca\\%
            Tel\'efono \eltelefon\\%
            Fax \elfax\\%
            \lemail\\%
            \elweb}}}%
      \def\@oddfoot{}}}%
%\InputIfFileExists{cartadma.cfg}{}{}
}

\def\enanglesoamerica#1{%
  \PassOptionsToPackage{catalan,american,#1}{babel}%
  \adreca{Cam\'{\i} de Vera, 14\\46022 Val\`encia (Spain)}%
  \ciutat{Val\`encia}%
  \def\alcoi{%
    \centre{EPS Alcoi}%
    \adreca{Passeig del Viaducte, 1\\03800 Alcoi (Spain)}%
    \ciutat{Alcoi}}%
  \def\vera{%
    \centre{}%
    \adreca{Cam\'{\i} de Vera, 14\\46022 Val\`encia (Spain)}%
    \ciutat{Val\`encia}}%
  \def\blasco{%
    \centre{EU Enginyeria T\`ecnica Agr\'\i cola}%
    \adreca{Avda.\ Blasco Ib\'a\~nez, 21\\46010 Val\`encia}%
    \ciutat{Val\`encia}}%
  \def\gandia{%
    \centre{EPS Gandia}%
    \adreca{Carretera Natzaret-Oliva, s/n\\46730 El Grau de Gandia
      (Spain)}%
    \ciutat{El Grau de Gandia}}%
                                %
  \AtBeginDocument{%
    \selectlanguage{#1}%
    \def\opening##1{%\ifx\@empty\fromaddress
    \thispagestyle{firstpage}%
    {\raggedleft\@date\par}%
                                %  \else  % home address
                                %    \thispagestyle{empty}%
                                %     {\raggedleft\begin{tabular}{l@{}}\ignorespaces
                                %       \fromaddress \\*[2\parskip]%
                                % %      \@date \end{tabular}\par}%
                                %       \end{tabular}\par}%
                                %  \fi
    %\vspace{2\parskip}%
    {\raggedright \toname \\ \toaddress \par}%
    \vspace{2\parskip}%
    ##1\par\nobreak}%
                                %
  \def\closing##1{\par\nobreak\vspace{\parskip}%
    \stopbreaks
    \noindent
                                % \ifx\@empty\fromaddress\else
    \hspace*{\longindentation}%
    \parbox{\indentedwidth}{\raggedright
      \ignorespaces ##1\\[\espaisignatura]\@lasignatura
      \ifx\@empty\fromsig
      \fromname
      \else \fromsig \fi\strut}%
    \par\medskip}%
  \def\ps@firstpage{%
    \def\@oddhead{\raisebox{34\p@}[\z@]{%
        \hspace*{-24mm}\resizebox{!}{15mm}{%
          \includegraphics{logoupvv\black}}\qquad
        \resizebox{!}{15mm}{\includegraphics{dmav}}}\qquad
      \raisebox{34\p@}[\z@]%
      {\parbox[b]{5cm}{\selectlanguage{catalan}\scriptsize\sffamily
          \ifthenelse{\equal{}{\elcentre}}{}{\elcentre \\ }
          \ladreca\\%
          Tel\`efon \eltelefon\\%
          Fax \elfax\\%
          \lemail\\%
          \elweb}}}%
    \def\@oddfoot{}}}%
%\InputIfFileExists{cartadma.cfg}{}{}
}%

\DeclareOption{english}{%
  \PassOptionsToPackage{catalan,english}{babel}%
  \enanglesoamerica{english}}
\DeclareOption{british}{%
  \PassOptionsToPackage{catalan,british}{babel}%
  \enanglesoamerica{british}}
\DeclareOption{american}{%
  \PassOptionsToPackage{catalan,american}{babel}%
  \enanglesoamerica{american}}

\DeclareOption{UKenglish}{%
  \PassOptionsToPackage{catalan,UKenglish}{babel}%
  \enanglesoamerica{UKenglish}}
\DeclareOption{USenglish}{%
  \PassOptionsToPackage{catalan,USenglish}{babel}%
  \enanglesoamerica{USenglish}}

\DeclareOption{a5paper}{}
\DeclareOption{b5paper}{}
\DeclareOption{letterpaper}{}
\DeclareOption{legalpaper}{}
\DeclareOption{executivepaper}{}
\DeclareOption{landscape}{}
\DeclareOption{twoside}{\@latexerr{No `twoside' layout for dma letters}%
                                   \@eha}

\DeclareOption*{\PassOptionsToClass{\CurrentOption}{letter}}

\ExecuteOptions{10pt,catalan,noblack}
\ProcessOptions*
\LoadClass[a4paper]{letter}
\InputIfFileExists{cartadma.cfg}{}{}
\date{\laciutatc\today}%
\def\seu{%
  \vera
  \telefon{96 387 7660 ext.\ 76660}%
  \fax{96 387 7669}%
  \email{depmat@upvnet.upv.es}%
  \web{http://www.dma.upv.es/}}
%
\def\@texttop{\ifnum\c@page=1\vskip \z@ plus.00001fil\relax\fi}
%\ifx\pdfoutput\@undefined\else\advance \oddsidemargin by -1cm \relax\fi
\ifx\pdfoutput\@undefined\else\pdfpagewidth=210mm\pdfpageheight=297mm\relax\fi


